﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Grid;

namespace GridGroupingControlTest
{
   public partial class Form1 : Form
   {
      # region dataTable
      private DataTable GetTable()
      {
         DataTable dt = new DataTable();

         //	DataColumn dcDate = new DataColumn("Date");
         DataColumn dcAttachment = new DataColumn("Attachment");
         DataColumn dcFrom = new DataColumn("From");
         DataColumn dcSubject = new DataColumn("Subject");
         DataColumn dcReceived = new DataColumn("Received", typeof(DateTime));

         DataColumn dcMails = new DataColumn("mails", typeof(int));
         DataColumn dcReadState = new DataColumn("ReadState", typeof(int));
         DataColumn dcTo = new DataColumn("To");
         DataColumn dcContent = new DataColumn("Content");
         //DataColumn dcflag = new DataColumn("flag", typeof(int));
         DataColumn dcSize = new DataColumn("Size", typeof(double));
         DataColumn dcPriority = new DataColumn("Priority");
         DataColumn dcCategory = new DataColumn("Category", typeof(string));

         dt.Columns.Add(dcAttachment);
         //dt.Columns.Add(dcDate);
         dt.Columns.Add(dcFrom);
         dt.Columns.Add(dcSubject);
         dt.Columns.Add(dcReceived);
         //
         dt.Columns.Add(dcMails);
         dt.Columns.Add(dcReadState);
         dt.Columns.Add(dcTo);
         dt.Columns.Add(dcContent);
         //dt.Columns.Add(dcflag);
         dt.Columns.Add(dcSize);
         dt.Columns.Add(dcPriority);
         dt.Columns.Add(dcCategory);

         dt.Rows.Add(new object[] { string.Empty, "Tindale", "Eval version Key", DateTime.Now, 0, 0, "Jake", "Please provide me the key to the new version", 5010, string.Empty, "Red Category"});
         dt.Rows.Add(new object[] { string.Empty, "Tony", "Re: Tool Missing ", DateTime.Now.AddMinutes(-2), 0, 0, "Jake", "Thanks Jake, Now it works", 29300, string.Empty, null });
         dt.Rows.Add(new object[] { string.Empty, "Brown", "Essential Grid ", DateTime.Now.AddHours(-1), 0, 0, "Jake", "Will you help me in purchasing Essential Grid", 5010, string.Empty, "Purple Category" });
         dt.Rows.Add(new object[] { string.Empty, "Sam", "Re:Latest Version", DateTime.Now.AddHours(-3), 0, 0, "Jake", "You can download the latest version now", 293000, 1, null });
         dt.Rows.Add(new object[] { string.Empty, "Ted", "UserAccount", DateTime.Now.AddHours(-3), 0, 0, "Jake", "User accounts have been created", 55000, 1, null });
         dt.Rows.Add(new object[] { string.Empty, "George", "Re: Solution", DateTime.Now.AddDays(-1), 0, 0, "Jake", "Thanks! This sorted the problem", 1025, string.Empty, null });
         dt.Rows.Add(new object[] { 1, "Paul", "New Image", DateTime.Now.AddDays(-10), 0, 0, "Jake", "Please have a look at this", 3453454, string.Empty, null });
         dt.Rows.Add(new object[] { 1, "Donald", "Re: icons", DateTime.Now.AddDays(-12), 2, 1, "Jake", "Please modify them", 3434100, string.Empty, null });
         dt.Rows.Add(new object[] { string.Empty, "Jerry", "Re: ", DateTime.Now.AddDays(-21), 2, 1, "Jake", "The feature is added now. It is ready for testing", 2033, -1, null });
         dt.Rows.Add(new object[] { string.Empty, "George", "Installaion Procedure", DateTime.Now.AddDays(-42), 2, 1, "Jake", "It is uploaded in server. Please go through this", 20400, string.Empty, null });
         dt.Rows.Add(new object[] { 1, "Paul", "Report Format", DateTime.Now.AddDays(-50), 3, 1, "Jake", "Please have a look at this", 3453440, 1, null });
         dt.Rows.Add(new object[] { string.Empty, "Donald", "Code Optimizer tool", DateTime.Now.AddDays(-63), 2, 1, "Jake", "Where can I found the complete documentation", 34341, string.Empty, null });
         dt.Rows.Add(new object[] { string.Empty, "Bob", "FeatureList", DateTime.Now.AddDays(-75), 2, 1, "Jake", "Could you please send me the list of new features ", 5010, string.Empty, null });
         dt.Rows.Add(new object[] { 1, "Sam", "Re: redraw issue", DateTime.Now.AddDays(-98), 1, 1, "Jake", "It is fixed", 293000, 1, null });
         dt.Rows.Add(new object[] { string.Empty, "Ted", "Re: Helper tool", DateTime.Now.AddDays(-100), 2, 1, "Jake", "This works great!!", 55000, 1, null });
         dt.Rows.Add(new object[] { string.Empty, "Babu", "Re:Defects", DateTime.Now.AddDays(-101), 1, 1, "Jake", "All Defects have been fixed.", 5010, string.Empty, null });
         dt.Rows.Add(new object[] { 1, "Domnique", "Code file missing", DateTime.Now.AddDays(-113), 2, 1, "Jake", "Could you please resend it again", 293000, -1, null });
         dt.Rows.Add(new object[] { string.Empty, "Haddok", "Re: resize problem", DateTime.Now.AddDays(-120), 2, 1, "Jake", "Thanks for your solution", 55000, 1, null });
         dt.Rows.Add(new object[] { string.Empty, "George", "Re: ReleaseDates", DateTime.Now.AddDays(-128), 3, 1, "Jake", "It will be announced tommorrow", 1025, string.Empty, null });
         dt.Rows.Add(new object[] { 1, "Paul", "Icons", DateTime.Now.AddDays(-199), 2, 1, "Jake", "Here is a list of icons", 3453454, string.Empty, null });
         dt.Rows.Add(new object[] { 1, "Donald", "Re: FeatureList", DateTime.Now.AddDays(-200), 1, 1, "Jake", "Please find the attachment for details", 3434100, string.Empty, null });
         dt.Rows.Add(new object[] { string.Empty, "Jerry", "Re:Latest Version", DateTime.Now.AddDays(-208), 2, 1, "Jake", "You can download the latest version now", 2033, -1, null });
         dt.Rows.Add(new object[] { string.Empty, "George", "Re: scrolling issue", DateTime.Now.AddDays(-259), 2, 1, "Jake", "It is fixed", 20400, string.Empty, null });
         dt.Rows.Add(new object[] { 1, "Paul", "New sample", DateTime.Now.AddDays(-270), 1, 1, "Jake", "Please test this", 3454540, 1, null });
         dt.Rows.Add(new object[] { string.Empty, "Don", "Re: Evaluation Keys", DateTime.Now.AddDays(-295), 2, 1, "Jake", "Hello, Finally decided purchasing Essential Grid.", 34341, string.Empty, null });
         dt.Rows.Add(new object[] { string.Empty, "George", "New website ", DateTime.Now.AddDays(-300), 1, 1, "Jake", "Please send me the link", 20400, string.Empty, null });
         dt.Rows.Add(new object[] { string.Empty, "Paul", "Refresh issues", DateTime.Now.AddDays(-350), 1, 1, "Jake", "Please check them", 3453540, 1, null });
         dt.Rows.Add(new object[] { 1, "Don", "Re: UI design", DateTime.Now.AddDays(-351), 2, 1, "Jake", "Thanks for your pointers! we came up with solution", 34341, string.Empty, "Green Category" });
         dt.Rows.Add(new object[] { string.Empty, "Neal Culiner", "Kudos Folks!!!", DateTime.Now.AddDays(-355), 2, 1, "Jake", "All I can say is WOW! Beautiful works!", 1025, string.Empty, "Purple Category" });
         dt.Rows.Add(new object[] { string.Empty, "Paul", "Re: License issue", DateTime.Now.AddDays(-356), 3, 1, "Jake", "Thanks!!", 3453454, string.Empty, null });
         dt.Rows.Add(new object[] { 1, "Don", "UI design", DateTime.Now.AddDays(-357), 3, 1, "Jake", "Will it be possible to tune grids as in the attachment.", 3434100, string.Empty, null });
         dt.Rows.Add(new object[] { string.Empty, "Jerry", "Evalutation", DateTime.Now.AddDays(-358), 2, 1, "Jake", "Testing is completed. This product works fine", 2033, string.Empty, null });
         dt.Rows.Add(new object[] { string.Empty, "Patrick", "Feedback", DateTime.Now.AddDays(-359), 2, 1, "Jake", "Thanks for your extraordinary support.", 20400, string.Empty, null });
         dt.Rows.Add(new object[] { string.Empty, "Paul", "License issue", DateTime.Now.AddDays(-360), 3, 1, "Jake", "How do I enable license to my customers?", 344540, 1, null });
         dt.Rows.Add(new object[] { string.Empty, "Don", "Evaluation Keys", DateTime.Now.AddDays(-365), 1, 1, "Jake", "Can you send the keys to test your produts.", 34341, string.Empty, null });
         return dt;
      }
      # endregion

      private static int red = 180, green = 180, blue = 180;

      private string path = @"C:\Documents and Settings\gkim\My Documents\syncfusion\essentialstudio\7.3.0.20\Windows\Grid.Grouping.Windows\Samples\2.0\Product Showcase\Outlook 2007 Demo\CS\res";
      public Form1()
      {
         InitializeComponent();

         gridGroupingControl1.DataSource = GetTable();
         gridGroupingControl1.TableDescriptor.GroupedColumns.Add("From");
         gridGroupingControl1.Appearance.GroupCaptionPlusMinusCell.CellType = "Image";
         gridGroupingControl1.Appearance.GroupCaptionPlusMinusCell.CellValue = Image.FromFile(Syncfusion.Windows.Forms.WinFormsUtils.FindFile(path, "plus.png"));


         gridGroupingControl1.TableModel.Properties.DisplayVertLines = false;
         gridGroupingControl1.TableModel.TableStyle.Trimming = StringTrimming.EllipsisCharacter;
         gridGroupingControl1.ChildGroupOptions.CaptionText = "{CategoryCaption}: {Category}";
         gridGroupingControl1.TopLevelGroupOptions.ShowCaption = false;

         gridGroupingControl1.TableOptions.RowHeaderWidth = 0;
         gridGroupingControl1.TableOptions.RecordRowHeight = 22;
         gridGroupingControl1.TableOptions.CaptionRowHeight = 30;
         gridGroupingControl1.TableOptions.AllowMultiColumnSort = false;
         gridGroupingControl1.Appearance.ColumnHeaderCell.Font.Facename = "Arial";
         gridGroupingControl1.Appearance.ColumnHeaderCell.Font.Size = 8;
         gridGroupingControl1.TableOptions.ColumnHeaderRowHeight = 30;
         gridGroupingControl1.Appearance.RecordFieldCell.Font.Facename = "Corbel";
         gridGroupingControl1.Appearance.RecordFieldCell.Font.Size = 8f;
         gridGroupingControl1.Appearance.AlternateRecordFieldCell.Font.Facename = "Corbel";
         gridGroupingControl1.Appearance.AlternateRecordFieldCell.Font.Size = 8f;

         // Selections (full row)
         gridGroupingControl1.TableOptions.SelectionBackColor = Color.LightGray;
         gridGroupingControl1.TableOptions.SelectionTextColor = SystemColors.ControlText;
         gridGroupingControl1.TableOptions.AllowSelection = GridSelectionFlags.Any;
         gridGroupingControl1.TableOptions.ListBoxSelectionCurrentCellOptions = GridListBoxSelectionCurrentCellOptions.HideCurrentCell;
         gridGroupingControl1.TableOptions.ListBoxSelectionColorOptions = GridListBoxSelectionColorOptions.ApplySelectionColor;
      }

      private void gridGroupingControl1_GroupCollapsed(object sender, Syncfusion.Grouping.GroupEventArgs e)
      {
         //GridCaptionRow gcr = (GridCaptionRow)e.Group.Caption.CaptionRows[0];
         //gcr.Appearance.GroupCaptionPlusMinusCell.CellValue = Image.FromFile(Syncfusion.Windows.Forms.WinFormsUtils.FindFile(path, "plus.png"));
      }

      private void gridGroupingControl1_GroupExpanded(object sender, Syncfusion.Grouping.GroupEventArgs e)
      {
         //GridCaptionRow gcr = (GridCaptionRow)e.Group.Caption.CaptionRows[0];
         //gcr.Appearance.GroupCaptionPlusMinusCell.CellValue = Image.FromFile(Syncfusion.Windows.Forms.WinFormsUtils.FindFile(path, "minus.png"));
      }

      private void gridGroupingControl1_TableControlCellClick(object sender, GridTableControlCellClickEventArgs e)
      {
         if (e.Inner.MouseEventArgs.Button == MouseButtons.Left)
         {
            if (e.Inner.RowIndex > 1)
            {
               GridTableCellStyleInfo style = e.TableControl.GetTableViewStyleInfo(e.Inner.RowIndex, e.Inner.ColIndex);
               if (style.TableCellIdentity.TableCellType == GridTableCellType.GroupCaptionPlusMinusCell)
               {
                  GridCaptionRow curGrp;

                  if (e.TableControl.Table.CurrentElement is GridCaptionSection)
                  {
                     GridCaptionSection cpSection = e.TableControl.Table.CurrentElement as GridCaptionSection;
                     curGrp = new GridCaptionRow(cpSection);
                  }
                  else
                  {
                     curGrp = e.TableControl.Table.CurrentElement as GridCaptionRow;
                  }

                  curGrp.ParentGroup.IsExpanded = !curGrp.ParentGroup.IsExpanded;
               }               
            }
         }
      }

      private void gridGroupingControl1_TableControlPrepareViewStyleInfo(object sender, GridTableControlPrepareViewStyleInfoEventArgs e)
      {
          //if (e.Inner.RowIndex > 0 && e.Inner.ColIndex > 0)
          //{
          //    if (gridGroupingControl1.TableControl.Selections.GetSelectedRows(true, false).AnyRangeContains(GridRangeInfo.Row(e.Inner.RowIndex)))
          //    {
          //        e.Inner.Style.TextColor = SystemColors.ControlText;
          //        e.Inner.Style.BackColor = Color.LightGray;
          //    }
          //}
      }

      private void gridGroupingControl1_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
      {
         if (e.TableCellIdentity.TableCellType == GridTableCellType.GroupCaptionCell)
         {
             e.Style.Themed = false;
             e.Style.BackColor = Color.White;
             e.Style.Borders.Top = new GridBorder(GridBorderStyle.None);
             e.Style.Borders.Bottom = new GridBorder(GridBorderStyle.Solid, Color.FromArgb(red, green, blue), GridBorderWeight.Thick);
             e.Style.TextMargins.Bottom = 0;
             e.Style.Font.Size = 8;
             e.Style.Font.Bold = true;
             e.Style.TextColor = Color.DimGray;
             e.Style.VerticalAlignment = GridVerticalAlignment.Middle;
         }
         if (e.TableCellIdentity.DisplayElement != null)
         {
             if (e.TableCellIdentity.Table.CurrentElement == e.TableCellIdentity.DisplayElement)
             {
                 e.Style.BackColor = Color.LightGray;
             }
         }
      }
   }
}
